/**
 * @author Copyright 2004 by Thomas Wenzlaff ( <a
 *         href=mailto://java@wenzlaff.de>java@wenzlaff.de </a>)
 * @see <a href=http://www.wenzlaff.de>www.wenzlaff.de </a>
 * @since 13.06.2004 11:35:22
 * 
 * Not Warranty to use it.
 */

package de.wenzlaff.twpadtrans;

import java.io.File;
import java.util.ArrayList;
import java.util.Collections;
import java.util.List;

import de.wenzlaff.twpadtrans.jaxb.DeuPAD;
import de.wenzlaff.twpadtrans.jaxb.Program_Info;
import de.wenzlaff.twpadtrans.jaxb.Web_Info;
import de.wenzlaff.twpadtrans.jaxb.XML_DIZ_INFO;
import de.wenzlaff.twpadtrans.schnittstelle.PadImpl;
import de.wenzlaff.twpadtrans.util.Verzeichnis;

/**
 * Beispiel Klasse die die Verwendung des TWPadTrans FrameWorkes aufzeigt.
 * 
 * Aufruf z.B:  
 * de.wenzlaff.twpadtrans.TWPadTrans "C:\Dokumente und Einstellungen\thomas\workspace-galileo\TWPadTransBeispiel\pad"
 *
 * @author Thomas Wenzlaff
 * @since 07.09.2009
 * @version 1.4.0
 * 
 */
public final class TWPadTrans {
	private static final String TAB = "\t";

	/**
	 * @param args
	 *            Verzeichnis wo die PAD Dateien liegen
	 */
	public static void main(String[] args) {
		if (args.length != 1) {
			System.out.println("TWPadTrans Syntax: TWPadTrans [Verzeichnis zu PAD Dateien]");
			System.out.println("Weitere Infos unter http://www.wenzlaff.de");
			return;
		}
		String lvPath = args[0];
		String lvDatei = "";
		System.out.println("TWPadTrans verwende PAD Verzeichnis: " + lvPath + "\n");

		// hole die Namen aller Pad Dateien
		Verzeichnis lvDir = new Verzeichnis(lvPath);
		List<String> lvDateinamenListe = lvDir.getAllePadDateiNamen();
		List<String> lvErgebnisListe = new ArrayList<String>();

		// fr jede PAD Datei...
		for (int i = 0; i < lvDateinamenListe.size(); i++) {
			lvDatei = (String) lvDateinamenListe.get(i);

			PadImpl lvPad = new PadImpl();

			// lese die PAD Datei in XML_DIZ_INFO
			XML_DIZ_INFO lvRoot = lvPad.getPadDokument(new File(lvPath + File.separator + lvDatei));

			// hole mir fr jeden gewnschten Eintrag das Objekt
			DeuPAD lvDeuPad = lvRoot.getXML_DIZ_INFOItem(0).getDeuPAD();
			Program_Info lvProgramInfo = lvRoot.getXML_DIZ_INFOItem(0).getProgram_Info();
			Web_Info lvWebInfo = lvRoot.getXML_DIZ_INFOItem(0).getWeb_Info();

			// in die Ergebnis Liste
			lvErgebnisListe.add(lvDeuPad.getSave_Prog_Num() + TAB + lvProgramInfo.getProgram_Version() + TAB
					+ lvProgramInfo.getProgram_Name() + TAB + "(" + lvDatei + ")");
		}
		// sortieren
		Collections.sort(lvErgebnisListe);
		// Ausgabe:
		for (int i = 0; i < lvErgebnisListe.size(); i++) {
			System.out.println(lvErgebnisListe.get(i));
		}
	}
}
